// DialogCommon_PropertySheet.h cvpeBV[g
#ifndef __WGC_DIALOGCOMMON_PROPERTYSHEET__
#define __WGC_DIALOGCOMMON_PROPERTYSHEET__

#include "./DialogCommon.h"
#include "./DialogPropertyPage.h"
#include <vector>


_WGC_BEGIN                              // namespace wgc {


class DialogCommon_PropertySheet : public DialogCommon
{
public:
	DialogCommon_PropertySheet(const UINT uCaptionID, HINSTANCE hResource, HWND hWndParent = NULL, const UINT nStartPage = 0, const DWORD dwPshFlags = PSH_DEFAULT);
	~DialogCommon_PropertySheet(void);

protected:
	typedef DialogPropertyPage *LPPROPPAGE_OBJ;

	void SetSheets(LPPROPPAGE_OBJ pPageArray[], const int nSheetCount);
	void SetPSH(PROPSHEETHEADER &psh) const;

	BOOL CreateCommonDialog_Modal   (const LPARAM dwInitParam, INT_PTR &iResult);
	BOOL CreateCommonDialog_Modeless(const LPARAM dwInitParam, INT_PTR &iResult);

	// Iy[V
	HWND GetTabControl(void) const;
	int  GetCurSel(void) const;
/*
	PropSheet_SetCurSel(hDlg, hpage, index)
	PropSheet_RemovePage(hDlg, index, hpage)
	PropSheet_AddPage(hDlg, hpage)
	PropSheet_Changed(hDlg, hwnd)
	PropSheet_RestartWindows(hDlg)
	PropSheet_RebootSystem(hDlg)
	PropSheet_CancelToClose(hDlg)
	PropSheet_QuerySiblings(hDlg, wParam, lParam)
	PropSheet_UnChanged(hDlg, hwnd)
	PropSheet_Apply(hDlg)
	PropSheet_SetTitle(hDlg, wStyle, lpszText)
	PropSheet_SetWizButtons(hDlg, dwFlags)
*/

	// z֐
	void AssociateDialogControls(void) {}
	void UpdateData(const BOOL /* bUpdate */ = TRUE) {}

private:
	UINT      m_uCaptionID;	                // _CAOLvṼ\[XID
	UINT      m_nStartPage;                 // PROPSHEETHEADER::nStartPage ̒l
	DWORD     m_dwPshFlags;	                // PROPSHEETHEADER::dwFlags ̒l

	tstring_t m_caption;
	std::vector<PROPSHEETPAGE> m_vPropSheetPage;

	// Rs[RXgN^AZq͎gps
	DISABLE_COPY(DialogCommon_PropertySheet)
};

_WGC_END                                // }

#endif // __WGC_DIALOGCOMMON_PROPERTYSHEET__
